//+------------------------------------------------------------------+
//|                                                  WeeklyPivot.mq4 |
//|                                                                  |
//+------------------------------------------------------------------+

#property indicator_chart_window
#property indicator_buffers 7
#property indicator_color1 Black
#property indicator_color2 Blue
#property indicator_color3 Blue
#property indicator_color4 Blue
#property indicator_color5 Blue
#property indicator_color6 Blue
#property indicator_color7 Blue
#property indicator_color8 Blue
//---- input parameters

//---- buffers
double PBuffer[];
double S1Buffer[];
double M2Buffer[];
double S2Buffer[];
double M1Buffer[];
double S3Buffer[];
double M0Buffer[];
double R1Buffer[];
string Pivot="WeeklyPivotPoint",WSup1="W_S 1", WM2="W_M 2";
string WSup2="W_S 2", WM1="W_M 1", WSup3="W_S 3", WM0="W_M 0" ,WRes1="W_R 1";
int fontsize=10;
double P,S1,M2,S2,M1,S3,M0,R1;
double last_week_high, last_week_low, this_week_open, last_week_close;

//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//---- TODO: add your code here

   ObjectDelete("WeeklyPivot");
   ObjectDelete("WSup1");
   ObjectDelete("WM2");
   ObjectDelete("WSup2");
   ObjectDelete("WM1");
   ObjectDelete("WSup3");
   ObjectDelete("WM0");  
   ObjectDelete("WRes1"); 

//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   string short_name;


//---- indicator line
   SetIndexStyle(0,DRAW_LINE,0,2,Magenta);
   SetIndexStyle(1,DRAW_LINE,0,2,Blue);
   SetIndexStyle(2,DRAW_LINE,0,2,Blue);
   SetIndexStyle(3,DRAW_LINE,0,2,Blue);
   SetIndexStyle(4,DRAW_LINE,0,2,Blue);
   SetIndexStyle(5,DRAW_LINE,0,2,Blue);
   SetIndexStyle(6,DRAW_LINE,0,2,Blue);
   SetIndexStyle(7,DRAW_LINE,0,2,Blue);
   SetIndexBuffer(0,PBuffer);
   SetIndexBuffer(1,S1Buffer);
   SetIndexBuffer(2,M2Buffer);
   SetIndexBuffer(3,S2Buffer);
   SetIndexBuffer(4,M1Buffer);
   SetIndexBuffer(5,S3Buffer);
   SetIndexBuffer(6,M0Buffer);
   SetIndexBuffer(7,R1Buffer);


//---- name for DataWindow and indicator subwindow label
   
   SetIndexLabel(0,"Weekly Pivot");
   SetIndexLabel(1,"Weekly S1");
   SetIndexLabel(2,"Weekly M2");
   SetIndexLabel(3,"Weekly S2");
   SetIndexLabel(4,"Weekly M1");
   SetIndexLabel(5,"Weekly S3");
   SetIndexLabel(6,"Weekly M0");
   SetIndexLabel(7,"Weekly R1");

//----
   SetIndexDrawBegin(0,1);
//----
 

//----
   return(0);
  }

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()

  {
   int counted_bars=IndicatorCounted();

   int limit, i;
//---- indicator calculation
if (counted_bars==0)

   if(counted_bars<0) return(-1);

   limit=(Bars-counted_bars)-1;


for (i=limit; i>=0;i--)
{ 


   // Monday
	if ( 1 == TimeDayOfWeek(Time[i]) && 1 != TimeDayOfWeek(Time[i+1]) )
	{
		last_week_close = Close[i+1];
		this_week_open = Open[i];

		// WeeklyPivot
		P = (last_week_high + last_week_low + last_week_close) / 3;

   R1 = (2*P)-last_week_low;
   S1 = (2*P)-last_week_high;
   M2 = (P+S1)/2;
   S2 = P-R1+S1;
   M1 = (S2+S1)/2;
   S3 = (2*P)-((2* last_week_high)-last_week_low);
   M0 = (S3+S2)/2;
  
   last_week_low=Low[i]; last_week_high=High[i];

	ObjectMove("WeeklyPivot", 0, Time[i],P);
   ObjectMove("WSup1", 0, Time[i],S1);
   ObjectMove("WM2", 0, Time[i],M2);
   ObjectMove("WSup2", 0, Time[i],S2);
   ObjectMove("WM1", 0, Time[i],M1);
   ObjectMove("WSup3", 0, Time[i],S3);
   ObjectMove("WM0", 0, Time[i],M0);
   ObjectMove("WRes1", 0, Time[i],R1);

}   
    
    last_week_high = MathMax(last_week_high, High[i]);
 	 last_week_low = MathMin(last_week_low, Low[i]);   
    PBuffer[i]=P;
    S1Buffer[i]=S1;
    M2Buffer[i]=M2;
    S2Buffer[i]=S2;
    M1Buffer[i]=M1;
    S3Buffer[i]=S3;
    M0Buffer[i]=M0;
    R1Buffer[i]=R1;

}

//----
   return(0);
  }
//+------------------------------------------------------------------+